# WARNING: Please don't edit this file. It was generated by Python/WinRT v2.0.1

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.foundation
import winrt.windows.foundation.collections
import winrt.windows.foundation.numerics
import winrt.windows.graphics.directx
import winrt.windows.graphics.directx.direct3d11
import winrt.windows.perception
import winrt.windows.perception.spatial
import winrt.windows.ui.core

from winrt.windows.graphics.holographic import HolographicDepthReprojectionMethod, HolographicFramePresentResult, HolographicFramePresentWaitBehavior, HolographicReprojectionMode, HolographicSpaceUserPresence, HolographicViewConfigurationKind

Self = typing.TypeVar('Self')

@typing.final
class HolographicAdapterId:
    low_part: winrt.system.UInt32
    high_part: winrt.system.Int32
    def __init__(self, low_part: winrt.system.UInt32, high_part: winrt.system.Int32) -> None: ...

@typing.final
class HolographicFrameId:
    value: winrt.system.UInt64
    def __init__(self, value: winrt.system.UInt64) -> None: ...

@typing.final
class HolographicStereoTransform:
    left: winrt.windows.foundation.numerics.Matrix4x4
    right: winrt.windows.foundation.numerics.Matrix4x4
    def __init__(self, left: winrt.windows.foundation.numerics.Matrix4x4, right: winrt.windows.foundation.numerics.Matrix4x4) -> None: ...

@typing.final
class HolographicCamera(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicCamera: ...
    def set_far_plane_distance(self, value: winrt.system.Double, /) -> None: ...
    def set_near_plane_distance(self, value: winrt.system.Double, /) -> None: ...
    @_property
    def viewport_scale_factor(self) -> winrt.system.Double: ...
    @viewport_scale_factor.setter
    def viewport_scale_factor(self, value: winrt.system.Double) -> None: ...
    @_property
    def id(self) -> winrt.system.UInt32: ...
    @_property
    def is_stereo(self) -> bool: ...
    @_property
    def render_target_size(self) -> winrt.windows.foundation.Size: ...
    @_property
    def display(self) -> typing.Optional[HolographicDisplay]: ...
    @_property
    def left_viewport_parameters(self) -> typing.Optional[HolographicCameraViewportParameters]: ...
    @_property
    def right_viewport_parameters(self) -> typing.Optional[HolographicCameraViewportParameters]: ...
    @_property
    def is_primary_layer_enabled(self) -> bool: ...
    @is_primary_layer_enabled.setter
    def is_primary_layer_enabled(self, value: bool) -> None: ...
    @_property
    def max_quad_layer_count(self) -> winrt.system.UInt32: ...
    @_property
    def quad_layers(self) -> typing.Optional[winrt.windows.foundation.collections.IVector[HolographicQuadLayer]]: ...
    @_property
    def can_override_viewport(self) -> bool: ...
    @_property
    def is_hardware_content_protection_enabled(self) -> bool: ...
    @is_hardware_content_protection_enabled.setter
    def is_hardware_content_protection_enabled(self, value: bool) -> None: ...
    @_property
    def is_hardware_content_protection_supported(self) -> bool: ...
    @_property
    def view_configuration(self) -> typing.Optional[HolographicViewConfiguration]: ...

@typing.final
class HolographicCameraPose(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicCameraPose: ...
    def override_projection_transform(self, projection_transform: HolographicStereoTransform, /) -> None: ...
    def override_view_transform(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], coordinate_system_to_view_transform: HolographicStereoTransform, /) -> None: ...
    def override_viewport(self, left_viewport: winrt.windows.foundation.Rect, right_viewport: winrt.windows.foundation.Rect, /) -> None: ...
    def try_get_culling_frustum(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], /) -> typing.Optional[typing.Optional[winrt.windows.perception.spatial.SpatialBoundingFrustum]]: ...
    def try_get_view_transform(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], /) -> typing.Optional[typing.Optional[HolographicStereoTransform]]: ...
    def try_get_visible_frustum(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], /) -> typing.Optional[typing.Optional[winrt.windows.perception.spatial.SpatialBoundingFrustum]]: ...
    @_property
    def far_plane_distance(self) -> winrt.system.Double: ...
    @_property
    def holographic_camera(self) -> typing.Optional[HolographicCamera]: ...
    @_property
    def near_plane_distance(self) -> winrt.system.Double: ...
    @_property
    def projection_transform(self) -> HolographicStereoTransform: ...
    @_property
    def viewport(self) -> winrt.windows.foundation.Rect: ...

@typing.final
class HolographicCameraRenderingParameters(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicCameraRenderingParameters: ...
    def commit_direct3_d11_depth_buffer(self, value: typing.Optional[winrt.windows.graphics.directx.direct3d11.IDirect3DSurface], /) -> None: ...
    @typing.overload
    def set_focus_point(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], position: winrt.windows.foundation.numerics.Vector3, /) -> None: ...
    @typing.overload
    def set_focus_point(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], position: winrt.windows.foundation.numerics.Vector3, normal: winrt.windows.foundation.numerics.Vector3, /) -> None: ...
    @typing.overload
    def set_focus_point(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], position: winrt.windows.foundation.numerics.Vector3, normal: winrt.windows.foundation.numerics.Vector3, linear_velocity: winrt.windows.foundation.numerics.Vector3, /) -> None: ...
    @_property
    def direct3_d11_back_buffer(self) -> typing.Optional[winrt.windows.graphics.directx.direct3d11.IDirect3DSurface]: ...
    @_property
    def direct3_d11_device(self) -> typing.Optional[winrt.windows.graphics.directx.direct3d11.IDirect3DDevice]: ...
    @_property
    def reprojection_mode(self) -> HolographicReprojectionMode: ...
    @reprojection_mode.setter
    def reprojection_mode(self, value: HolographicReprojectionMode) -> None: ...
    @_property
    def is_content_protection_enabled(self) -> bool: ...
    @is_content_protection_enabled.setter
    def is_content_protection_enabled(self, value: bool) -> None: ...
    @_property
    def depth_reprojection_method(self) -> HolographicDepthReprojectionMethod: ...
    @depth_reprojection_method.setter
    def depth_reprojection_method(self, value: HolographicDepthReprojectionMethod) -> None: ...

@typing.final
class HolographicCameraViewportParameters(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicCameraViewportParameters: ...
    @_property
    def hidden_area_mesh(self) -> winrt.windows.foundation.numerics.Vector2: ...
    @_property
    def visible_area_mesh(self) -> winrt.windows.foundation.numerics.Vector2: ...

@typing.final
class HolographicDisplay_Static(type):
    def get_default(cls) -> typing.Optional[HolographicDisplay]: ...

@typing.final
class HolographicDisplay(winrt.system.Object, metaclass=HolographicDisplay_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicDisplay: ...
    def try_get_view_configuration(self, kind: HolographicViewConfigurationKind, /) -> typing.Optional[HolographicViewConfiguration]: ...
    @_property
    def adapter_id(self) -> HolographicAdapterId: ...
    @_property
    def display_name(self) -> str: ...
    @_property
    def is_opaque(self) -> bool: ...
    @_property
    def is_stereo(self) -> bool: ...
    @_property
    def max_viewport_size(self) -> winrt.windows.foundation.Size: ...
    @_property
    def spatial_locator(self) -> typing.Optional[winrt.windows.perception.spatial.SpatialLocator]: ...
    @_property
    def refresh_rate(self) -> winrt.system.Double: ...

@typing.final
class HolographicFrame(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFrame: ...
    def get_quad_layer_update_parameters(self, layer: typing.Optional[HolographicQuadLayer], /) -> typing.Optional[HolographicQuadLayerUpdateParameters]: ...
    def get_rendering_parameters(self, camera_pose: typing.Optional[HolographicCameraPose], /) -> typing.Optional[HolographicCameraRenderingParameters]: ...
    @typing.overload
    def present_using_current_prediction(self) -> HolographicFramePresentResult: ...
    @typing.overload
    def present_using_current_prediction(self, wait_behavior: HolographicFramePresentWaitBehavior, /) -> HolographicFramePresentResult: ...
    def update_current_prediction(self) -> None: ...
    def wait_for_frame_to_finish(self) -> None: ...
    @_property
    def added_cameras(self) -> typing.Optional[winrt.windows.foundation.collections.IVectorView[HolographicCamera]]: ...
    @_property
    def current_prediction(self) -> typing.Optional[HolographicFramePrediction]: ...
    @_property
    def duration(self) -> datetime.timedelta: ...
    @_property
    def removed_cameras(self) -> typing.Optional[winrt.windows.foundation.collections.IVectorView[HolographicCamera]]: ...
    @_property
    def id(self) -> HolographicFrameId: ...

@typing.final
class HolographicFramePrediction(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFramePrediction: ...
    @_property
    def camera_poses(self) -> typing.Optional[winrt.windows.foundation.collections.IVectorView[HolographicCameraPose]]: ...
    @_property
    def timestamp(self) -> typing.Optional[winrt.windows.perception.PerceptionTimestamp]: ...

@typing.final
class HolographicFramePresentationMonitor(winrt.system.Object):
    def __enter__(self: Self) -> Self: ...
    def __exit__(self, *args) -> None: ...
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFramePresentationMonitor: ...
    def close(self) -> None: ...
    def read_reports(self) -> typing.Optional[winrt.windows.foundation.collections.IVectorView[HolographicFramePresentationReport]]: ...

@typing.final
class HolographicFramePresentationReport(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFramePresentationReport: ...
    @_property
    def app_gpu_duration(self) -> datetime.timedelta: ...
    @_property
    def app_gpu_overrun(self) -> datetime.timedelta: ...
    @_property
    def compositor_gpu_duration(self) -> datetime.timedelta: ...
    @_property
    def missed_presentation_opportunity_count(self) -> winrt.system.UInt32: ...
    @_property
    def presentation_count(self) -> winrt.system.UInt32: ...

@typing.final
class HolographicFrameRenderingReport(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFrameRenderingReport: ...
    @_property
    def frame_id(self) -> HolographicFrameId: ...
    @_property
    def missed_latch_count(self) -> winrt.system.UInt32: ...
    @_property
    def system_relative_actual_gpu_finish_time(self) -> datetime.timedelta: ...
    @_property
    def system_relative_frame_ready_time(self) -> datetime.timedelta: ...
    @_property
    def system_relative_target_latch_time(self) -> datetime.timedelta: ...

@typing.final
class HolographicFrameScanoutMonitor(winrt.system.Object):
    def __enter__(self: Self) -> Self: ...
    def __exit__(self, *args) -> None: ...
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFrameScanoutMonitor: ...
    def close(self) -> None: ...
    def read_reports(self) -> typing.Optional[winrt.windows.foundation.collections.IVector[HolographicFrameScanoutReport]]: ...

@typing.final
class HolographicFrameScanoutReport(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicFrameScanoutReport: ...
    @_property
    def missed_scanout_count(self) -> winrt.system.UInt32: ...
    @_property
    def rendering_report(self) -> typing.Optional[HolographicFrameRenderingReport]: ...
    @_property
    def system_relative_latch_time(self) -> datetime.timedelta: ...
    @_property
    def system_relative_photon_time(self) -> datetime.timedelta: ...
    @_property
    def system_relative_scanout_start_time(self) -> datetime.timedelta: ...

@typing.final
class HolographicQuadLayer(winrt.system.Object):
    def __enter__(self: Self) -> Self: ...
    def __exit__(self, *args) -> None: ...
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicQuadLayer: ...
    @typing.overload
    def __new__(cls: typing.Type[HolographicQuadLayer], size: winrt.windows.foundation.Size) -> HolographicQuadLayer:...
    @typing.overload
    def __new__(cls: typing.Type[HolographicQuadLayer], size: winrt.windows.foundation.Size, pixel_format: winrt.windows.graphics.directx.DirectXPixelFormat) -> HolographicQuadLayer:...
    def close(self) -> None: ...
    @_property
    def pixel_format(self) -> winrt.windows.graphics.directx.DirectXPixelFormat: ...
    @_property
    def size(self) -> winrt.windows.foundation.Size: ...

@typing.final
class HolographicQuadLayerUpdateParameters(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicQuadLayerUpdateParameters: ...
    def acquire_buffer_to_update_content(self) -> typing.Optional[winrt.windows.graphics.directx.direct3d11.IDirect3DSurface]: ...
    def acquire_buffer_to_update_content_with_hardware_protection(self) -> typing.Optional[winrt.windows.graphics.directx.direct3d11.IDirect3DSurface]: ...
    def update_content_protection_enabled(self, value: bool, /) -> None: ...
    def update_extents(self, value: winrt.windows.foundation.numerics.Vector2, /) -> None: ...
    def update_location_with_display_relative_mode(self, position: winrt.windows.foundation.numerics.Vector3, orientation: winrt.windows.foundation.numerics.Quaternion, /) -> None: ...
    def update_location_with_stationary_mode(self, coordinate_system: typing.Optional[winrt.windows.perception.spatial.SpatialCoordinateSystem], position: winrt.windows.foundation.numerics.Vector3, orientation: winrt.windows.foundation.numerics.Quaternion, /) -> None: ...
    def update_viewport(self, value: winrt.windows.foundation.Rect, /) -> None: ...
    @_property
    def can_acquire_with_hardware_protection(self) -> bool: ...

@typing.final
class HolographicSpace_Static(type):
    def create_for_core_window(cls, window: typing.Optional[winrt.windows.ui.core.CoreWindow], /) -> typing.Optional[HolographicSpace]: ...
    def add_is_available_changed(cls, handler: winrt.windows.foundation.EventHandler[winrt.system.Object], /) -> winrt.windows.foundation.EventRegistrationToken: ...
    def remove_is_available_changed(cls, token: winrt.windows.foundation.EventRegistrationToken, /) -> None: ...
    @_property
    def is_available(cls) -> bool: ...
    @_property
    def is_supported(cls) -> bool: ...
    @_property
    def is_configured(cls) -> bool: ...

@typing.final
class HolographicSpace(winrt.system.Object, metaclass=HolographicSpace_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicSpace: ...
    def create_frame_presentation_monitor(self, max_queued_reports: winrt.system.UInt32, /) -> typing.Optional[HolographicFramePresentationMonitor]: ...
    def create_frame_scanout_monitor(self, max_queued_reports: winrt.system.UInt32, /) -> typing.Optional[HolographicFrameScanoutMonitor]: ...
    def create_next_frame(self) -> typing.Optional[HolographicFrame]: ...
    def set_direct3_d11_device(self, value: typing.Optional[winrt.windows.graphics.directx.direct3d11.IDirect3DDevice], /) -> None: ...
    def wait_for_next_frame_ready(self) -> None: ...
    def wait_for_next_frame_ready_with_head_start(self, requested_head_start_duration: datetime.timedelta, /) -> None: ...
    def add_camera_added(self, handler: winrt.windows.foundation.TypedEventHandler[HolographicSpace, HolographicSpaceCameraAddedEventArgs], /) -> winrt.windows.foundation.EventRegistrationToken: ...
    def remove_camera_added(self, cookie: winrt.windows.foundation.EventRegistrationToken, /) -> None: ...
    def add_camera_removed(self, handler: winrt.windows.foundation.TypedEventHandler[HolographicSpace, HolographicSpaceCameraRemovedEventArgs], /) -> winrt.windows.foundation.EventRegistrationToken: ...
    def remove_camera_removed(self, cookie: winrt.windows.foundation.EventRegistrationToken, /) -> None: ...
    def add_user_presence_changed(self, handler: winrt.windows.foundation.TypedEventHandler[HolographicSpace, winrt.system.Object], /) -> winrt.windows.foundation.EventRegistrationToken: ...
    def remove_user_presence_changed(self, token: winrt.windows.foundation.EventRegistrationToken, /) -> None: ...
    @_property
    def primary_adapter_id(self) -> HolographicAdapterId: ...
    @_property
    def user_presence(self) -> HolographicSpaceUserPresence: ...

@typing.final
class HolographicSpaceCameraAddedEventArgs(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicSpaceCameraAddedEventArgs: ...
    def get_deferral(self) -> typing.Optional[winrt.windows.foundation.Deferral]: ...
    @_property
    def camera(self) -> typing.Optional[HolographicCamera]: ...

@typing.final
class HolographicSpaceCameraRemovedEventArgs(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicSpaceCameraRemovedEventArgs: ...
    @_property
    def camera(self) -> typing.Optional[HolographicCamera]: ...

@typing.final
class HolographicViewConfiguration(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> HolographicViewConfiguration: ...
    def request_render_target_size(self, size: winrt.windows.foundation.Size, /) -> winrt.windows.foundation.Size: ...
    @_property
    def pixel_format(self) -> winrt.windows.graphics.directx.DirectXPixelFormat: ...
    @pixel_format.setter
    def pixel_format(self, value: winrt.windows.graphics.directx.DirectXPixelFormat) -> None: ...
    @_property
    def is_enabled(self) -> bool: ...
    @is_enabled.setter
    def is_enabled(self, value: bool) -> None: ...
    @_property
    def display(self) -> typing.Optional[HolographicDisplay]: ...
    @_property
    def is_stereo(self) -> bool: ...
    @_property
    def kind(self) -> HolographicViewConfigurationKind: ...
    @_property
    def native_render_target_size(self) -> winrt.windows.foundation.Size: ...
    @_property
    def refresh_rate(self) -> winrt.system.Double: ...
    @_property
    def render_target_size(self) -> winrt.windows.foundation.Size: ...
    @_property
    def supported_pixel_formats(self) -> typing.Optional[winrt.windows.foundation.collections.IVectorView[winrt.windows.graphics.directx.DirectXPixelFormat]]: ...
    @_property
    def supported_depth_reprojection_methods(self) -> typing.Optional[winrt.windows.foundation.collections.IVectorView[HolographicDepthReprojectionMethod]]: ...

